; 
    include \masm32\include\masm32rt.inc
; 

comment * -----------------------------------------------------
                        Build this  template with
                       "CONSOLE ASSEMBLE AND LINK"
        ----------------------------------------------------- *

; ====================================

    ftext MACRO hFile:REQ,args:VARARG
      LOCAL lcnt,var                        ;; LOCAL loop counter

      push esi                              ;; preserve ESI
      mov esi, alloc(16384)                 ;; allocate 16k of buffer

      lcnt = argcount(args)                 ;; get the VARARG argument count
      REPEAT lcnt

      var equ repargof(getarg(lcnt,args))
      ;; ----------------------------------------------
      ;; if argument a register, display error and stop
      ;; ----------------------------------------------
        IF op_type(repargof(getarg(lcnt,args))) EQ 4
          echo -------------------------------------------
        % echo Argument num2str(lcnt) INVALID OPERAND in ftext macro
          echo ERROR Register or register return
          echo value not allowed in this context
          echo Valid options are,
          echo *        1. quoted text
          echo *        2. zero terminated string address
          echo *        3. macro that returns an OFFSET
          echo *        4. built in character operators
          echo -------------------------------------------
          .err
        ENDIF
        IFIDN var,<lb>                      ;; ( notation
          IFNDEF @left_bracket@
            .data
              @left_bracket@ db "(",0
            .code
          ENDIF
          push OFFSET @left_bracket@
          goto overit
        ENDIF
        IFIDN var,<rb>                      ;; ) notation
          IFNDEF @right_bracket@
            .data
              @right_bracket@ db ")",0
            .code
          ENDIF
          push OFFSET @right_bracket@
          goto overit
        ENDIF
        IFIDN var,<la>                      ;; < notation
          IFNDEF @left_angle@
            .data
              @left_angle@ db "<",0
            .code
          ENDIF
          push OFFSET @left_angle@
          goto overit
        ENDIF
        IFIDN var,<ra>                      ;; > notation
          IFNDEF @right_angle@
            .data
              @right_angle@ db ">",0
            .code
          ENDIF
          push OFFSET @right_angle@
          goto overit
        ENDIF
        IFIDN var,<q>                       ;; quote notation
          IFNDEF @quote@
            .data
              @quote@ db 34,0
            .code
          ENDIF
          push OFFSET @quote@
          goto overit
        ENDIF
        IFIDN var,<n>                       ;; newline notation
          IFNDEF @nln@
            .data
              @nln@ db 13,10,0
            .code
          ENDIF
          push OFFSET @nln@
          goto overit
        ENDIF
        IFIDN var,<t>                       ;; tab notation
          IFNDEF @tab@
            .data
              @tab@ db 9,0
            .code
          endif
          push offset @tab@
          goto overit
        ENDIF

      push var                              ;; push current argument

      :overit
        lcnt = lcnt - 1
      ENDM

      push esi                              ;; push the buffer address
      push argcount(args)                   ;; push the argument count
      call szMultiCat                       ;; call the C calling procedure
      add esp, argcount(args)*4+8           ;; correct the stack

      push eax
      invoke WriteFile,hFile,esi,len(esi),esp,NULL
      pop eax

      free esi                              ;; free the memory buffer
      pop esi                               ;; restore ESI
    ENDM

; ====================================

    .code

start:
   
; 

    call main

    exit

; 

main proc

    LOCAL hFile :DWORD
    LOCAL mystr :DWORD

    sas mystr,"Hi folks"

    mov hFile, fcreate("tst.txt")

    ftext hFile,t,mystr,n, \
                t,t,"This is a test",n, \
                t,t,t,"Of the new ftext macro",n, \
                t,t,t,t,"using the preprocessor in MASM",n,n

    ftext hFile,q,"Quoted text written to file",q,n, \
                lb,"Text in brackets",rb,n, \
                la,"Text in angle brackets",ra,n

    fclose hFile

    fn WinExec,"\masm32\qeditor.exe tst.txt", 1

    ret

main endp

; 

end start
